# Spațiul de nume

DNS organizează numele resurselor într-o ierarhie de domenii. Un domeniu
reprezintă o colecție de sisteme gazdă care au unele proprietăți în
comun, cum ar fi faptul că toate aparțin unei aceleiași organizații sau
faptul că toate sunt situate geografic în același perimetru.

![](images/dns.gif)

Fiecare domeniu este partiționat în subdomenii și acestea sunt la rândul
lor, partiționate, ș.a.m.d. Toate aceste domenii pot fi reprezentate ca
un arbore, după cum se poate vedea mai sus. Frunzele arborelui
reprezintă domenii care nu au subdomenii, dar care conțin totuși
sisteme. Un domeniu frunză poate conține de la un singur sistem gazdă
până la mii de sisteme gazdă.

Domeniile de pe primul nivel se împart în două categorii: generice
(gTLD-uri) și de țări (ccTLD-uri). Domeniile generice inițiale erau
*com* (comercial), *edu* (instituții educaționale), *gov* (guvernul
SUA), *int* (organizații internaționale), *mil* (forțele armate ale SUA)
și *org* (organizații nonprofit). În ziua de astăzi, restricțiile legate
de astfel de domenii sunt mult mai mici, existând astfel peste 1200 de
domenii top-level generice. Domeniile de țări includ o intrare pentru
fiecare țară, după cum se definește în ISO
[3166](https://www.iso.org/iso-3166-country-codes.html). Fiecare domeniu
este denumit de calea în arbore până la rădăcină. Componentele sunt
separate prin punct. Astfel, departamentul de Calculatoare de la UPB
poate fi *cs.pub.ro* în loc de numele în stil UNIX */ro/pub/cs*.

Numele de domenii pot fi absolute sau relative. Un nume absolut de
domeniu (FQDN - fully qualified domain name) este un nume de domeniu
care nu permite nici o ambiguitate cu privire la locația relativă la
rădăcina arborelui de nume de domenii. Astfel de nume absolute de
domenii se termină cu punct (de exemplu *cs.pub.ro.*). În contrast, un
nume relativ de domeniu este un nume care are sens numai relativ la un
anume domeniu DNS (altul decât cel rădăcină).

Numele de domenii nu fac distincție între litere mici și litere mari,
*edu* sau *EDU* însemnând practic același lucru. Componentele numelor
pot avea o lungime de cel mult 64 de caractere, iar întreaga cale de
nume nu trebuie să depășească 255 de caractere.

Fiecare domeniu controlează cum sunt alocate domeniile de sub el. De
exemplu, Japonia are domeniile *ac.jp* și *co.jp* echivalente cu *edu*
și *com*. Olanda nu face nicio distincție și pune toate organizațiile
direct sub *nl*. Pentru a crea un nou domeniu, se cere permisiunea
domeniului în care va fi inclus. De exemplu, dacă un grup PCom de la CS
dorește să fie cunoscut ca *pcom.cs.pub.ro*, acesta are nevoie de
permisiunea celui care administrează *cs.pub.ro*. Similar, o nouă
universitate care dorește obținerea unui domeniu va trebui să ceară
permisiunea administratorului domeniului *edu*. În acest mod, sunt
evitate conflictele de nume și fiecare domeniu poate ține evidența
tuturor subdomeniilor sale. Odată ce un nou domeniu a fost creat și
înregistrat, el poate crea subdomenii, fără a cere permisiune de la
cineva din partea superioară a arborelui.
