# Cereri DNS în terminalul Linux

În Linux, pentru a obține adresele IP ale unei gazde, putem folosi unul
din utilitarele *host* sau *nslookup*:

    $ host google.com
    google.com has address 172.217.20.14
    google.com has IPv6 address 2a00:1450:400d:804::200e
    google.com mail is handled by 30 alt2.aspmx.l.google.com.
    google.com mail is handled by 50 alt4.aspmx.l.google.com.
    google.com mail is handled by 20 alt1.aspmx.l.google.com.
    google.com mail is handled by 10 aspmx.l.google.com.
    google.com mail is handled by 40 alt3.aspmx.l.google.com.

    $ nslookup google.com
    Server:     192.168.100.1
    Address:    192.168.100.1#53

    Non-authoritative answer:
    Name:   google.com
    Address: 172.217.20.14

Pentru aflarea unui nume pe baza unei adrese IP, se pot folosi tot
*host* sau *nslookup*:

    $ host 8.8.8.8
    8.8.8.8.in-addr.arpa domain name pointer dns.google.

    $ nslookup 8.8.8.8
    8.8.8.8.in-addr.arpa    name = dns.google.

    Authoritative answers can be found from:
    in-addr.arpa    nameserver = a.in-addr-servers.arpa.
    in-addr.arpa    nameserver = b.in-addr-servers.arpa.
    in-addr.arpa    nameserver = c.in-addr-servers.arpa.
    in-addr.arpa    nameserver = e.in-addr-servers.arpa.
    in-addr.arpa    nameserver = d.in-addr-servers.arpa.
    in-addr.arpa    nameserver = f.in-addr-servers.arpa.

Un exemplu de output *tcpdump* pentru comanda *host* este mai jos (unde
53 este portul implicit pentru DNS):

    $ sudo tcpdump port 53
    tcpdump: data link type PKTAP
    tcpdump: verbose output suppressed, use -v or -vv for full protocol decode
    listening on pktap, link-type PKTAP (Apple DLT_PKTAP), capture size 262144 bytes

    08:12:17.446368 IP 192.168.100.4.63991 > 192.168.100.1.domain: 31461+ A? google.com. (28)
    08:12:17.450412 IP 192.168.100.1.domain > 192.168.100.4.63991: 31461 1/0/0 A 172.217.16.110 (44)
    08:12:18.455598 IP 192.168.100.4.58146 > 192.168.100.1.domain: 4039+ AAAA? google.com. (28)
    08:12:18.463761 IP 192.168.100.1.domain > 192.168.100.4.58146: 4039 1/0/0 AAAA 2a00:1450:400d:803::200e (56)
    08:12:19.467330 IP 192.168.100.4.53016 > 192.168.100.1.domain: 58519+ MX? google.com. (28)
    08:12:19.514778 IP 192.168.100.1.domain > 192.168.100.4.53016: 58519 5/0/0 MX alt3.aspmx.l.google.com. 40,
    MX alt4.aspmx.l.google.com. 50, MX aspmx.l.google.com. 10, MX alt1.aspmx.l.google.com. 20,
    MX alt2.aspmx.l.google.com. 30 (136)
