# Endianness

În funcție de ordinea în care un șir de octeti este **stocat în memorie** avem două interpretări: **Little Endian** și **Big Endian**. Reprezentarea cu care suntem cel mai bine obișnuiți este Big Endian, așa cum reprezentăm datele pe foaie, cel mai semnificativ byte este primul. În imaginea de mai jos avem un exemplu de cum un `int` pe 32 de biți, `0x01020304` poate avea valori diferite în funcție de cum este interpretat. De notat faptul că endianness-ul este același pentru un char (1 byte)

![](images/endianness_figure1.webp)

În general, procesoarele moderne folosesc Little Endian. Totuși, plăcile de rețea, folosesc Big Endian. O să întâlnim denumirea **Network Order (Big Endian)** și **Host Order (Little Endian)**.

În API-ul POSIX avem mai multe funcții care se pot folosi pentru a face trecerea Host Order <-> Network Order:
```C
#include <arpa/inet.h>

// host to network long
uint32_t htonl(uint32_t hostlong); 
uint16_t htons(uint16_t hostshort); 
// network to host long
uint32_t ntohl(uint32_t netlong);
uint16_t ntohs(uint16_t netshort)
```
