# Exercitii


> **Scheletul laboratorului se regăsește la adresa de
[aici](https://gitlab.cs.pub.ro/pcom/pcom-laboratoare-public/-/tree/master/lab5).  Verificati sa aveti ultima versiune de schelet. Funcționalitatea disponibilă este descrisă în README.md. În continuare vom folosi Mininet pentru a simula topologia simpla: `sudo python3 topo.py`.**

**1\.** Scheletul de cod are o implementare simplă de client-server peste UDP
folosind API-ul de sockets. Vom deschide pe router o instanță de
`Wireshark` pentru a studia datagrama trimisa de sender. Cum arată
datagramele trimise de către sender? Care este portul sursa?

> Pe `h1` vom rula clientul, iar pe `h2` serverul. Routerul rulează pe `r0`.

**2** Plecând de la scheletul de cod implementați
protocolul **stop-and-wait** pentru a trimite conținutul unui fisier de la sender
la receiver. Fisierul va fi trimis în bucati de maxim 1024 bytes. La final, vom măsura
timpul de rulare al serverului. Topologia din Mininet pe care o vom folosi este următoarea:

``` 
             L1               L2
client (h1) <--> router (r1) <--> server (h2)

Link 1 - 10 Mbps, 5ms delay, 0% packet loss (linia 57 din topo.py)
Link 2 - 10 Mbps, 5ms delay, 0% packet loss (linia 60 din topo.py)

h1 IP: 192.168.1.100
h2 IP: 172.16.0.100
```

---
**Note**

După ce am testat manual ca implementarea este corectă, vom folosi `sudo python3 topo.py benchmark`
pentru a măsura performanța implementării noastre. De exemplu, dat fiind că avem un delay de
`5 ms`, observam un runtime total al serverului de `30 ms`, din care `10 ms` cât a stat blocat
în `recv()` ca să ajungă datagramele la el și alte `20 ms` din alte surse (e.g. overhead de la OS). Exemplu de output:
```
##### Benchmark results #####
[Server] Received: Hello world!
Total time = 0.030401 seconds
#############################
```

---

**3** Pentru a folosi link-ul intr-un mod optim, vom modifica implementarea
de stop-and-wait sa folosească o **fereastră glisantă** de dimensiune optimă.
Astfel, vom calcula BDP-ul pentru fiecare link si vom alege minimul dintre ele, pentru a evita congestionarea ambelor segmente.
Dimensiunea (în datagrame a) ferestrei optime este `[BDP / datagram_size]`. Cu ce procent este mai rapidă aceasta implementare?

**4** Ne vom conecta toți în aceași rețea (e.g. pe acelasi WiFi) pentru
a trimite fișiere către alți colegi din sala. Nu vom mai rula peste Mininet.
Ne vom **grupa câte doi** pentru a trimite un fișier de la unul la celalalt. 
Mai exact, unul dintre voi va porni un server cu bind pe `INADDR_ANY`
(0.0.0.0), iar clientul va putea trimite catre ip-ul celuilalt fisierul. 

---
**Note**

Dacă folosiți mașini virtuale și nu aveți rețeaua pe modul Bridge, va
trebui să faceți port forwarding din setarile hypervisorului. Pentru
a verifica dacă sunteți în aceeasi retea, folositi `ip address
show` și confirmați că adresa este din același subnet cu cel al gazdei.

---
