## Transport reliable peste UDP

În unele cazuri, nu avem nevoie de transmisie reliable peste UDP (e.g.
streaming web unde daca pierdem câteva cadre, putem interpola la
receiver). Totuși, deseori avem nevoie să știm cu certitudine că un
mesaj a ajuns în partea cealaltă. Pentru a rezolva această problemă vom
studia implementari de tip **sliding window**, mai exact **cazul simplu în care fereastra de transmisie este egala cu 1**.

Un exemplu de protocol reliable peste UDP este Quick UDP Internet
Connections (QUIC) dezvoltat de Google in 2012.

### Stop and Wait

Unul dintre cele mai simple metode de a transmite datele peste un mediu
în care datagramele se pot pierde este protocolul stop and wait. În
cadrul protocolului, sender-ul va trimite un frame și la primirea unei
datagrame de ACK, va trimite urmatorul frame. Sender-ul folosește un
timeout pentru retransmisie în cazul în care o datagramă este pierdută.

![](images/e-stop1.png)

Stop and wait este un caz particular de protocol ce foloseste sliding
windows, în cazul acesta windows\_size = 1. Pentru a înțelege mai bine
conceptul de fereastră glsiantă vă recomandăm următorul
[simulator](https://www2.tkn.tu-berlin.de/teaching/rn/animations/gbn_sr/)
ce implementeaza doi algoritmi diferiți: **go-back-n** și **selective
repeat**.

De notat faptul ca aceasta metoda este generală și nu se aplica doar la
nivelul transport. TCP folosește o fereastră de transmitere, dar
întâlnim acest concept și la nivele mai joase din stiva OSI.
